# Default provider build options (MySQL, Postgres, unixODBC, LDAP, FreeTDS)
#
# Package build options:
# --with db2
# --with oracle
# --with sybase
# --without ldap
# --without mdb
# --without mysql
# --without odbc
# --without postgres
# --without tds
# --without xbase
# --without java
# 

%define           IBMDB2   0
%define           ORACLE   0
%define           SYBASE   0
%define           LDAP     0
%define           MDB      1
%define           MYSQL    1
%define           ODBC     0
%define           POSTGRES 1
%define           FREETDS  0
%define           XBASE    0
%define           JAVA     0

%{?_with_db2:%define IBMDB2     1}
%{?_with_oracle:%define ORACLE  1}
%{?_with_sybase:%define SYBASE  1}
%{?_without_ldap:%define LDAP   0}
%{?_without_mdb:%define MDB     0}
%{?_without_mysql:%define MYSQL 0}
%{?_without_odbc:%define ODBC   0}
%{?_without_postgres:%define POSTGRES 0}
%{?_without_tds:%define FREETDS 0}
%{?_without_xbase:%define XBASE 0}
%{?_with_java:%define JAVA 1}

Name:             libgda41
Epoch:            1
Version:          4.1.1
Release:          2%{?dist}.xobas
Summary:          Library for writing gnome database programs
Group:            System Environment/Libraries
License:          LGPLv2+
URL:              http://www.gnome-db.org/
Source:           http://ftp.gnome.org/pub/GNOME/sources/%{name}/4.1/libgda-%{version}.tar.bz2
Patch3:           libgda-4.1.1-lib64.patch
BuildRoot:        %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildRequires:    pkgconfig >= 0.8
BuildRequires:    glib2-devel >= 2.16
BuildRequires:    libxslt-devel >= 1.0.9
BuildRequires:    sqlite-devel >= 3.6.0
BuildRequires:    gamin-devel >= 0.1.8
BuildRequires:    libxml2-devel readline-devel db4-devel
BuildRequires:    gtk-doc scrollkeeper intltool gettext flex bison perl(XML::Parser)
# note we do not provide these, they no longer exist
Obsoletes:        %{name}-sharp < %{epoch}:%{version}-%{release}
Obsoletes:        %{name}-sharp-devel < %{epoch}:%{version}-%{release}

Obsoletes:        %{name}-freetds < %{epoch}:3.99.0
Obsoletes:        %{name}-freetds-devel < %{epoch}:3.99.0
Obsoletes:        %{name}-ldap < %{epoch}:3.99.0
Obsoletes:        %{name}-ldap-devel < %{epoch}:3.99.0
Obsoletes:        %{name}-odbc < %{epoch}:3.99.0
Obsoletes:        %{name}-odbc-devel < %{epoch}:3.99.0
Obsoletes:        %{name}-xbase < %{epoch}:3.99.0
Obsoletes:        %{name}-xbase-devel < %{epoch}:3.99.0

%if %{FREETDS}
BuildRequires:    freetds-devel >= 0.82-2
%endif

%if %{MYSQL}
BuildRequires:    mysql-devel
%endif

%if %{POSTGRES}
BuildRequires:    postgresql-devel
%endif

%if %{ODBC}
BuildRequires:    unixODBC-devel
%endif

%if %{MDB}
BuildRequires:    mdbtools-devel
%endif

%if %{LDAP}
BuildRequires:    openldap-devel
%endif

%if %{XBASE}
BuildRequires:    xbase-devel
%endif

%description
libgda is a library that eases the task of writing
gnome database programs.


%package devel
Summary:          Development libraries and header files for libgda
Group:            Development/Libraries
Requires:         glib2-devel >= 2.0.0
Requires:         libxslt-devel >= 1.0.9
Requires:         db4-devel libxml2-devel pkgconfig
Requires:         %{name} = %{epoch}:%{version}-%{release}

%description devel
This package contains the header files and libraries needed to write
or compile programs that use libgda.


%package ui
Summary:          libgda UI
Group:            Applications/Databases
Requires:         %{name} = %{epoch}:%{version}-%{release}
%description ui
This package includes the libgda UI.

%package ui-devel
Summary:          libgda UI pkgconfig file
Group:            Development/Libraries
Requires:         pkgconfig
Requires:         %{name}-ui = %{epoch}:%{version}-%{release}

%description ui-devel
This package includes the pkgconfig file for the libgda SQLite provider.

%package sqlite
Summary:          SQLite provider for libgda
Group:            System Environment/Libraries
Requires:         %{name} = %{epoch}:%{version}-%{release}
Obsoletes:        gda-sqlite < %{epoch}:%{version}-%{release}
Provides:         gda-sqlite = %{epoch}:%{version}-%{release}
%description sqlite
This package includes the libgda SQLite provider.

%package sqlite-devel
Summary:          SQLite provider for libgda pkgconfig file
Group:            Development/Libraries
Requires:         pkgconfig
Requires:         %{name}-sqlite = %{epoch}:%{version}-%{release}
%description sqlite-devel
This package includes the pkgconfig file for the libgda SQLite provider.


%if %{FREETDS}
%package freetds
Summary:          FreeTDS provider for libgda
Group:            System Environment/Libraries
Requires:         %{name} = %{epoch}:%{version}-%{release}
Obsoletes:        gda-freetds < %{epoch}:%{version}-%{release}
Provides:         gda-freetds = %{epoch}:%{version}-%{release}
%description freetds
This package includes the libgda FreeTDS provider.

%package freetds-devel
Summary:          FreeTDS provider for libgda pkgconfig file
Group:            Development/Libraries
Requires:         pkgconfig
Requires:         %{name}-freetds = %{epoch}:%{version}-%{release}
%description freetds-devel
This package includes the pkgconfig file for the libgda FreeTDS provider.
%endif

%if %{IBMDB2}
%package ibmdb2
Summary:          IBM DB2 provider for libgda
Group:            System Environment/Libraries
Requires:         %{name} = %{epoch}:%{version}-%{release}
Obsoletes:        gda-ibmdb2 < %{epoch}:%{version}-%{release}
Provides:         gda-ibmdb2 = %{epoch}:%{version}-%{release}
%description ibmdb2
This package includes the libgda IBM DB2 provider.

%package ibmdb2-devel
Summary:          IBM DB2 provider for libgda pkgconfig file
Group:            Development/Libraries
Requires:         pkgconfig
Requires:         %{name}-ibmdb2 = %{epoch}:%{version}-%{release}
%description ibmdb2-devel
This package includes the pkgconfig file for the libgda IBM DB2 provider.
%endif

%if %{MYSQL}
%package mysql
Summary:          MySQL provider for libgda
Group:            System Environment/Libraries
Requires:         %{name} = %{epoch}:%{version}-%{release}
Obsoletes:        gda-mysql < %{epoch}:%{version}-%{release}
Provides:         gda-mysql = %{epoch}:%{version}-%{release}
%description mysql
This package includes the libgda MySQL provider.

%package mysql-devel
Summary:          MySQL provider for libgda pkgconfig file
Group:            Development/Libraries
Requires:         pkgconfig
Requires:         %{name}-mysql = %{epoch}:%{version}-%{release}
%description mysql-devel
This package includes the pkgconfig file for the libgda MySQL provider.
%endif

%if %{ODBC}
%package odbc
Summary:          ODBC provider for libgda
Group:            System Environment/Libraries
Requires:         %{name} = %{epoch}:%{version}-%{release}
Obsoletes:        gda-odbc < %{epoch}:%{version}-%{release}
Provides:         gda-odbc = %{epoch}:%{version}-%{release}
%description odbc
This package includes the libgda ODBC provider.

%package odbc-devel
Summary:          ODBC provider for libgda pkgconfig file
Group:            Development/Libraries
Requires:         pkgconfig
Requires:         %{name}-odbc = %{epoch}:%{version}-%{release}
%description odbc-devel
This package includes the pkgconfig file for the libgda ODBC provider.
%endif

%if %{ORACLE}
%package oracle
Summary:          Oracle provider for libgda
Group:            System Environment/Libraries
Requires:         %{name} = %{epoch}:%{version}-%{release}
Obsoletes:        gda-oracle < %{epoch}:%{version}-%{release}
Provides:         gda-oracle = %{epoch}:%{version}-%{release}
%description oracle
This package includes the libgda Oracle provider.

%package oracle-devel
Summary:          Oracle provider for libgda pkgconfig file
Group:            Development/Libraries
Requires:         pkgconfig
Requires:         %{name}-oracle = %{epoch}:%{version}-%{release}
%description oracle-devel
This package includes the pkgconfig file for the libgda Oracle provider.
%endif

%if %{POSTGRES}
%package postgres
Summary:          PostgreSQL provider for libgda
Group:            System Environment/Libraries
Requires:         %{name} = %{epoch}:%{version}-%{release}
Obsoletes:        gda-postgres < %{epoch}:%{version}-%{release}
Provides:         gda-postgres = %{epoch}:%{version}-%{release}
%description postgres
This package includes the libgda PostgreSQL provider.

%package postgres-devel
Summary:          PostgreSQL provider for libgda pkgconfig file
Group:            Development/Libraries
Requires:         pkgconfig
Requires:         %{name}-postgres = %{epoch}:%{version}-%{release}
%description postgres-devel
This package includes the pkgconfig file for the libgda PostgreSQL provider.
%endif

%if %{SYBASE}
%package sybase
Summary:          Sybase provider for libgda
Group:            System Environment/Libraries
Requires:         %{name} = %{epoch}:%{version}-%{release}
Obsoletes:        gda-sybase < %{epoch}:%{version}-%{release}
Provides:         gda-sybase = %{epoch}:%{version}-%{release}
%description sybase
This package includes the libgda Sybase provider.

%package sybase-devel
Summary:          Sybase provider for libgda pkgconfig file
Group:            Development/Libraries
Requires:         pkgconfig
Requires:         %{name}-sybase = %{epoch}:%{version}-%{release}
%description sybase-devel
This package includes the pkgconfig file for the libgda Sybase provider.
%endif

%if %{MDB}
%package mdb
Summary:          MDB provider for libgda
Group:            System Environment/Libraries
Requires:         %{name} = %{epoch}:%{version}-%{release}
Obsoletes:        gda-mdb < %{epoch}:%{version}-%{release}
Provides:         gda-mdb = %{epoch}:%{version}-%{release}
%description mdb
This package includes the libgda MDB provider.

%package mdb-devel
Summary:          MDB provider for libgda pkgconfig file
Group:            Development/Libraries
Requires:         pkgconfig
Requires:         %{name}-mdb = %{epoch}:%{version}-%{release}
%description mdb-devel
This package includes the pkgconfig file for the libgda MDB provider.
%endif
		
%if %{LDAP}
%package ldap
Summary:          LDAP provider for libgda
Group:            System Environment/Libraries
Requires:         %{name} = %{epoch}:%{version}-%{release}
Obsoletes:        gda-ldap < %{epoch}:%{version}-%{release}
Provides:         gda-ldap = %{epoch}:%{version}-%{release}
%description ldap
This package includes the libgda LDAP provider.

%package ldap-devel
Summary:          LDAP provider for libgda pkgconfig file
Group:            Development/Libraries
Requires:         pkgconfig
Requires:         %{name}-ldap = %{epoch}:%{version}-%{release}
%description ldap-devel
This package includes the pkgconfig file for the libgda LDAP provider.
%endif

%if %{XBASE}
%package xbase
Summary:          XBASE provider for libgda
Group:            System Environment/Libraries
Requires:         %{name} = %{epoch}:%{version}-%{release}
%description xbase
This package includes the GDA XBASE provider.

%package xbase-devel
Summary:          XBASE provider for libgda pkgconfig file
Group:            Development/Libraries
Requires:         %{name}-xbase = %{epoch}:%{version}-%{release}, pkgconfig
%description xbase-devel
This package includes the pkgconfig file for the libgda XBASE provider.
%endif


%prep
%setup -q -n libgda-%{version}
%patch3 -p1 -b .lib64
# fix ppc64 postgres detection
sed -i 's/x86_64\* | sparc64\*) lib="lib64";;/x86_64\* | sparc64\* | powerpc64\*) lib="lib64";;/' \
  configure configure.in
# stop autoxxx rerunning because of our patches above
touch aclocal.m4
touch `find -name Makefile.in`


%build
CONFIG="--disable-static --disable-dependency-tracking"

%if %{FREETDS}
CONFIG="$CONFIG --with-tds"
%else
CONFIG="$CONFIG --without-tds"
%endif

%if %{IBMDB2}
CONFIG="$CONFIG --with-ibmdb2"
%else
CONFIG="$CONFIG --without-ibmdb2"
%endif

%if %{MYSQL}
CONFIG="$CONFIG --with-mysql"
%else
CONFIG="$CONFIG --without-mysql"
%endif

%if %{POSTGRES}
CONFIG="$CONFIG --with-postgres"
%else
CONFIG="$CONFIG --without-postgres"
%endif

%if %{ODBC}
CONFIG="$CONFIG --with-odbc"
%else
CONFIG="$CONFIG --without-odbc"
%endif

%if %{ORACLE}
CONFIG="$CONFIG --with-oracle"
%else
CONFIG="$CONFIG --without-oracle"
%endif

%if %{SYBASE}
CONFIG="$CONFIG --with-sybase"
%else
CONFIG="$CONFIG --without-sybase"
%endif

%if %{MDB}
CONFIG="$CONFIG --with-mdb"
%else
CONFIG="$CONFIG --without-mdb"
%endif

%if %{LDAP}
CONFIG="$CONFIG --with-ldap"
%else
CONFIG="$CONFIG --without-ldap"
%endif

%if %{XBASE}
CONFIG="$CONFIG --with-xbase"
%else
CONFIG="$CONFIG --without-xbase"
%endif

%if %{JAVA}
CONFIG="$CONFIG --with-java"
%else
CONFIG="$CONFIG --without-java"
%endif

#%configure $CONFIG
configure  \
        --prefix=/opt/libgda41 \
        --exec-prefix=/opt/libgda41 \
        --libdir=/opt/libgda41/%_lib \
        --bindir=/opt/libgda41/bin \
        --sbindir=/opt/libgda41/sbin \
        --sysconfdir=/opt/libgda41/etc \
        --datadir=/opt/libgda41/share \
        --includedir=/opt/libgda41/include \
        --localstatedir=/opt/libgda41/var \
        --mandir=/opt/libgda41/share/man \
        --infodir=/opt/libgda41/share/info \
	$CONFIG

# Don't use rpath!
sed -i 's|^hardcode_libdir_flag_spec=.*|hardcode_libdir_flag_spec=""|g' libtool
sed -i 's|^runpath_var=LD_RUN_PATH|runpath_var=DIE_RPATH_DIE|g' libtool
# work around gda-report-test-3.0 linking failing because of the disabling of
# rpath above
export LD_LIBRARY_PATH=`pwd`/libsql/.libs
make %{?_smp_mflags}


%install
rm -rf $RPM_BUILD_ROOT
make install DESTDIR=$RPM_BUILD_ROOT

# Move doc files in correct place
mkdir -p $RPM_BUILD_ROOT/opt/libgda41/share/doc
cp -rf AUTHORS COPYING ChangeLog README NEWS $RPM_BUILD_ROOT/opt/libgda41/share/doc

# Move DTD files in correct place
mkdir -p $RPM_BUILD_ROOT/opt/libgda41/share/libgda-4.0/dtd
cp -rf libgda/*.dtd $RPM_BUILD_ROOT/opt/libgda41/share/libgda-4.0/dtd

# Cleanup unnecessary, unpackaged files
find $RPM_BUILD_ROOT -type f -name "*.la" -exec rm -f {} ';'
rm $RPM_BUILD_ROOT/opt/libgda41/etc/libgda-4.0/sales_test.db

%find_lang libgda-4.0


%post -p /sbin/ldconfig

%post devel
if which scrollkeeper-update >/dev/null 2>&1; then scrollkeeper-update; fi

%postun -p /sbin/ldconfig

%postun devel
if which scrollkeeper-update >/dev/null 2>&1; then scrollkeeper-update; fi


%clean
rm -rf $RPM_BUILD_ROOT


%files -f libgda-4.0.lang
%defattr(-,root,root,-)
%doc /opt/libgda41/share/doc/AUTHORS
%doc /opt/libgda41/share/doc/COPYING
%doc /opt/libgda41/share/doc/ChangeLog
%doc /opt/libgda41/share/doc/README
%doc /opt/libgda41/share/doc/NEWS
%config(noreplace) /opt/libgda41/etc/libgda-4.0
/opt/libgda41/bin/gda-list*
/opt/libgda41/bin/gda-sql*
/opt/libgda41/bin/gda-test*
/opt/libgda41/bin/gda_trml*
/opt/libgda41/share/libgda-4.0
/opt/libgda41/%_lib/*.so.*
%dir /opt/libgda41/%_lib/libgda-4.0
%dir /opt/libgda41/%_lib/libgda-4.0/providers
# note this file really should be in its own subpackage too, but libgda
# needs to have atleast one provider present to be of any use.
/opt/libgda41/%_lib/libgda-4.0/providers/libgda-bdb.so
/opt/libgda41/share/man/man1/*

%files devel
%defattr(-,root,root,-)
%doc /opt/libgda41/share/gtk-doc/html/libgda-4.0
/opt/libgda41/include/*
/opt/libgda41/%_lib/*.so
/opt/libgda41/%_lib/pkgconfig/libgda-4.0.pc
/opt/libgda41/%_lib/pkgconfig/libgda-bdb-4.0.pc
/opt/libgda41/%_lib/pkgconfig/libgda-report-4.0.pc
/opt/libgda41/%_lib/pkgconfig/libgda-xslt-4.0.pc

%files ui
%defattr(-,root,root,-)
/opt/libgda41/bin/gda-browser*
/opt/libgda41/bin/gda-control-center*
/opt/libgda41/bin/gdaui-demo*
/opt/libgda41/share/applications/*.desktop
/opt/libgda41/share/libgda/icons/*
/opt/libgda41/share/pixmaps/gda-browser*.png
/opt/libgda41/share/pixmaps/gda-control-center*.png
/opt/libgda41/%_lib/libgda-4.0/plugins/gdaui-entry-*.xml
/opt/libgda41/%_lib/libgda-4.0/plugins/libgda-ui-plugins.so

%files ui-devel
%defattr(-,root,root,-)
/opt/libgda41/%_lib/pkgconfig/libgda-ui-4.0.pc

%files sqlite
%defattr(-,root,root,-)
/opt/libgda41/%_lib/libgda-4.0/providers/libgda-sqlite.so

%files sqlite-devel
%defattr(-,root,root,-)
/opt/libgda41/%_lib/pkgconfig/libgda-sqlite-4.0.pc

%if %{FREETDS}
%files freetds
%defattr(-,root,root,-)
/opt/libgda41/%_lib/libgda-4.0/providers/libgda-freetds.so

%files freetds-devel
%defattr(-,root,root,-)
/opt/libgda41/%_lib/pkgconfig/libgda-freetds-4.0.pc
%endif

%if %{IBMDB2}
%files ibmdb2
%defattr(-,root,root,-)
/opt/libgda41/%_lib/libgda-4.0/providers/libgda-ibmdb2.so

%files ibmdb2-devel
%defattr(-,root,root,-)
/opt/libgda41/%_lib/pkgconfig/libgda-imdb2-4.0.pc
%endif

%if %{MYSQL}
%files mysql
%defattr(-,root,root,-)
/opt/libgda41/%_lib/libgda-4.0/providers/libgda-mysql.so

%files mysql-devel
%defattr(-,root,root,-)
/opt/libgda41/%_lib/pkgconfig/libgda-mysql-4.0.pc
%endif

%if %{ODBC}
%files odbc
%defattr(-,root,root,-)
/opt/libgda41/%_lib/libgda-4.0/providers/libgda-odbc.so

%files odbc-devel
%defattr(-,root,root,-)
/opt/libgda41/%_lib/pkgconfig/libgda-odbc-4.0.pc
%endif

%if %{ORACLE}
%files oracle
%defattr(-,root,root,-)
/opt/libgda41/%_lib/libgda-4.0/providers/libgda-oracle.so

%files oracle-devel
%defattr(-,root,root,-)
/opt/libgda41/%_lib/pkgconfig/libgda-oracle-4.0.pc
%endif

%if %{POSTGRES}
%files postgres
%defattr(-,root,root,-)
/opt/libgda41/%_lib/libgda-4.0/providers/libgda-postgres.so

%files postgres-devel
%defattr(-,root,root,-)
/opt/libgda41/%_lib/pkgconfig/libgda-postgres-4.0.pc
%endif

%if %{SYBASE}
%files sybase
%defattr(-,root,root,-)
/opt/libgda41/%_lib/libgda-4.0/providers/libgda-sybase.so

%files sybase-devel
%defattr(-,root,root,-)
/opt/libgda41/%_lib/pkgconfig/libgda-sybase-4.0.pc
%endif

%if %{MDB}
%files mdb
%defattr(-,root,root,-)
/opt/libgda41/%_lib/libgda-4.0/providers/libgda-mdb.so

%files mdb-devel
%defattr(-,root,root,-)
/opt/libgda41/%_lib/pkgconfig/libgda-mdb-4.0.pc
%endif

%if %{LDAP}
%files ldap
%defattr(-,root,root,-)
/opt/libgda41/%_lib/libgda-4.0/providers/libgda-ldap.so

%files ldap-devel
%defattr(-,root,root,-)
/opt/libgda41/%_lib/pkgconfig/libgda-ldap-4.0.pc
%endif

%if %{XBASE}
%files xbase
%defattr(-,root,root)
/opt/libgda41/%_lib/libgda-4.0/providers/libgda-xbase.so

%files xbase-devel
%defattr(-,root,root,-)
/opt/libgda41/%_lib/pkgconfig/libgda-xbase-4.0.pc
%endif


%changelog
* Tue Aug 25 2009  <bas.driessen@xobas.com> - 1:4.1.1-2
- Update to completed and released 4.1.1 upstream release.
- Add icons to ui package.

- Fork from libgda-4.0.0 source from Fedora 11 project.
* Sun Aug 23 2009  <bas.driessen@xobas.com> - 1:4.1.1-1.20090818git
- Fork from libgda-4.0.0 source from Fedora 11 project.
- Update to git snapshot 4.1.1 2009-08-18.
- Remove outdated patch 1 (man).
- Add ui package.
- Install in /opt/libgda41 to prevent mix-up with stock libgda packages.

